<template lang="pug">
b-card( :title='`Рассылка`' )
	template( v-if='campagin' )
		.block( v-if='campagin.group' )
			b-field( label="Отправлено:" )
				template( #labelRight ) Заблокирован у: {{ campagin.blocked }}/{{ campagin.group.clients.length }}
				.progress-field
					p.data.is-flex.is-align-items-center.is-justify-content-center
						span.sended {{ campagin.sended.length }}
						span.separator /
						span.total {{ campagin.group.clients.length }}
					progress.progress.is-medium( :value='campagin.sended.length' :class='{ "is-danger": campagin.status == "stoped", "is-primary": campagin.status == "pending", "is-success": campagin.status == "sended" }' :max='campagin.group.clients.length' )
		.block
			b-field( label="Текст сообщения:" )
				.message
					.message-body
						.docs.is-flex.is-align-items-flex-start.is-justify-content-flex-start.mb-2( v-if='docs && docs.length' )
							b-file.ml-2( v-for='(file, i) in docs' :key='i' :file='file' type="file" )
						.images.is-flex.is-align-items-flex-start.is-justify-content-flex-start.mt-2.mb-2( v-if='images && images.length' )
							b-file.ml-2( v-for='(file, i) in images' :key='i' :file='file' )
						p( v-html='campagin.message' )
	template( #footer )
		template( v-if='campagin && campagin.status == "created"' )
			a.has-text-success( v-if='campagin.group' @click='start' ) Начать рассылку
			a.has-text-danger( @click='remove' ) Удалить рассылку
		template( v-if='campagin && campagin.status == "pending"' )
			a.has-text-warning( @click='stop' ) Приостановить рассылку
		template( v-if='campagin && campagin.status == "stoped"' )
			a.has-text-success( v-if='campagin.group' @click='start' ) Продолжить рассылку
</template>

<script setup>
import BFile from "@/components/chat/File.vue"
import BField from "@/components/form/Field.vue"

import { computed, onMounted, ref } from "vue"
import { useRoute, useRouter } from "vue-router"
import { useSocket } from "@/stores/socket"
import { useCampaginStore } from "@/stores/campagin"

const io = useSocket()
const cs = useCampaginStore()

const $route = useRoute()
const $router = useRouter()

const campagin = ref(null)
const id = computed(() => $route.params.id)
const docs = computed(() => campagin.value?.files?.filter(({ bucket }) => bucket == "files"))
const images = computed(() => campagin.value?.files?.filter(({ bucket }) => bucket == "images"))

const fetch = async () =>  campagin.value = await cs.getCampagin(id.value)

const start = async () => {
	await cs.startCampagin(id.value)
	fetch()
}
const stop = async () => {
	await cs.stopCampagin(id.value)
	fetch()
}

const remove = async () => {
	await cs.removeCampagin(id.value)
	$router.push({ name: "Campagins" })
}

onMounted(() => {
	io.on(`progress_${id.value}`, ({ sended, blocked }) => {
		campagin.value.sended = sended
		campagin.value.blocked = blocked
	})
	io.on(`success_${id.value}`, fetch)
	fetch()
})
</script>

<style lang="scss" scoped>
.progress-field {
	position: relative;
	.data {
		font-size: .875rem;
		margin: auto;
		position: absolute;
		top: 0;
		right: 0;
		bottom: 0;
		left: 0;
	}
}
</style>